#!/bin/bash
#

_version="1.01"
_date="18.12.2017"

_cmd=$1
_url=$2
_path=$3


_port=""
_dfile="/home/httpd/ramdisk/anshttp.dat"
_sfile="/home/httpd/ramdisk/site.html"
_freesitelist="/home/httpd/ramdisk/freesite.slt"	#спсписок листинга свободного доступа. формат: <option>35.187.81.58:80</option>
_ddfile=""
_Status_Code=""
_Old_Status_Code=""
_data=""
((_memmin=750))

_sppfp1URL=""
_sppfp1port=""
#
_usefile=""



function _help()
{
	echo -e "======= br1site.sh Version:$_version Date:$_date ======="
	echo -e "help                  - текущая подсказка"
	echo -e "site <url> <path>     - работа по указанному адресу и пути с сайтом"
	echo -e "sfsite <url>          - поиск свободных свйтов"
	echo -e ""
}


function _dsite()
{
	#echo "send..."
	res=$(./sndhttp.sh -get $_url $_path)
	_data=$res
	#echo "analise..."
	./anshttp.sh -afc "$res"
	_ddfile=$(cat "$_dfile")
	#echo -e "$_ddfile"
	_Status_Code=$(echo -e "$_ddfile" | awk '/Status-Code:/ {print($2)}')
	_Location=$(echo -e "$_ddfile" | awk '/Location:/ {print($2)}')
	#echo -e ""	
	#echo -e "==============================="
	#echo -e "Код возврата: $_Status_Code"
	#echo -e "Путь:         $_Location"
	#echo -e "==============================="
	#echo -e ""
}

function _site()
{
	str=$(echo -e "$_url" | sed "s/:/ /g")
	turl=$(echo -e "$str" | awk '{print($1)}')
	tport=$(echo -e "$str" | awk '{print($2)}')
	if [ "$tport" == "" ]; then
 	 tport="80"
	fi
	echo -e "URL:$turl Port:$tport"
	str=$(nc -4 -w 10 -vvz "$turl" "$tport" 2>&1)
	res=$(echo "$str" | grep "succeeded!")
	if [ "$res" == "" ]; then
	 res=$(echo "$str" | grep "open")
	fi
	if [ "$res" == "" ]; then
	 echo -e "=== Not Host: $turl or Port: $tport ===" > "$_dfile"
	 exit -1
	fi
	_dsite
	((loop = 1))
	while( ((loop > 0)) ); do
		echo -e "$_data" > "$_sfile"
		case $_Status_Code in
			"200")
				exit 0
			;;
			"301")
				_path=$_Location
				_dsite
				if [ "$_Old_Status_Code" == "301" ]; then
					exit 301
				fi
				_Old_Status_Code=$_Status_Code
			;;	
			"302")
				_path=$_Location
				_dsite
				if [ "$_Old_Status_Code" == "302" ]; then
					exit 302
				fi
				_Old_Status_Code=$_Status_Code
			;;
			"307")
				_path=$_Location
				_dsite
				if [ "$_Old_Status_Code" == "307" ]; then
					exit 307
				fi
				_Old_Status_Code=$_Status_Code
			;;
			*)
				exit 2
			;;
		esac
	done
}

#функция "потока"
function _sfsfp1()
{
	((work = 0))
	lurl=$_sppfp1URL
	lport=$_sppfp1port
	lpath="/"
	echo "Url:$lurl Port:$lport"
	str=$(nc -4 -w1 -vvz $lurl $lport 2>&1)
	res=$(echo "$str" | grep "succeeded!")
	if [ "$res" == "" ]; then
	 res=$(echo "$str" | grep "open")
	fi
	if [ "$res" != "" ]; then
	 ((work = 255))
	else
	 echo "NO SITE... res:$res URL:$lurl Port:$lport"
	fi
	if ( ((work > 0)) ); then
	 echo "work"
	 #echo "send..."
	 
	 #_data=$res
	 #echo "analise..."
	 
	 #echo -e "$_ddfile"
	 
	 ((loop = 255))
	 while( ((loop > 0)) ); do
	  res=$(./sndhttp.sh -get $lurl":"$lport $lpath)
	  ./anshttp.sh -afc "$res"
	  _ddfile=$(cat "$_dfile")
	  _Status_Code=$(echo -e "$_ddfile" | awk '/Status-Code:/ {print($2)}')
	  _Location=$(echo -e "$_ddfile" | awk '/Location:/ {print($2)}')
	  case $_Status_Code in
			"200")
				echo -e "<option>$lurl:$lport</option>" >> "$_freesitelist"
				((loop = 0))
			;;
			"301")
				lpath=$_Location
				_dsite
				if [ "$_Old_Status_Code" == "301" ]; then
					((loop = 0))
				fi
				_Old_Status_Code=$_Status_Code
			;;	
			"302")
				lpath=$_Location
				_dsite
				if [ "$_Old_Status_Code" == "302" ]; then
					((loop = 0))
				fi
				_Old_Status_Code=$_Status_Code
			;;
			"307")
				lpath=$_Location
				_dsite
				if [ "$_Old_Status_Code" == "307" ]; then
					((loop = 0))
				fi
				_Old_Status_Code=$_Status_Code
			;;
			*)
				((loop = 0))
			;;
		esac
	 done
	fi
}

#поиск свободных сайтов
function _search_free_sites()
{
	(( pcnt = 0 ))
	str=$(echo -e "$_url" | sed "s/:/ /g")
	lurl=$(echo -e "$str" | awk '{print($1)}')
	lport=$(echo -e "$str" | awk '{print($2)}')
	if [ "$lport" == "" ]; then
	 lport="80"
	fi 
	#echo "" > "$_file_res"
	#echo "work" > "$_file_stat"
	#адреса
	str=$(echo -e $_url | sed "s/\./ /g")
	echo "str=$str url:$lurl port:$lport"
	ip1=$(echo -e $str | awk '{print($1)}')
	ip2=$(echo -e $str | awk '{print($2)}')
	ip3=$(echo -e $str | awk '{print($3)}')
	ip4=$(echo -e $str | awk '{print($4)}')
	#
	ip1=$(echo -e $ip1 | sed "s/-/ /g")
	ip2=$(echo -e $ip2 | sed "s/-/ /g")
	ip3=$(echo -e $ip3 | sed "s/-/ /g")
	ip4=$(echo -e $ip4 | sed "s/-/ /g")
	#
	ip1_1=$(echo -e $ip1 | awk '{print($1)}')
	ip1_2=$(echo -e $ip1 | awk '{print($2)}')
	if [ "$ip1_2" == "" ]; then
	ip1_2=$ip1_1
	fi
	ip2_1=$(echo -e $ip2 | awk '{print($1)}')
	ip2_2=$(echo -e $ip2 | awk '{print($2)}')
	if [ "$ip2_2" == "" ]; then
	ip2_2=$ip2_1
	fi
	ip3_1=$(echo -e $ip3 | awk '{print($1)}')
	ip3_2=$(echo -e $ip3 | awk '{print($2)}')
	if [ "$ip3_2" == "" ]; then
	ip3_2=$ip3_1
	fi
	ip4_1=$(echo -e $ip4 | awk '{print($1)}')
	ip4_2=$(echo -e $ip4 | awk '{print($2)}')
	if [ "$ip4_2" == "" ]; then
	ip4_2=$ip4_1
	fi
	_startURL="$ip1_1.$ip2_1.$ip3_1.$ip4_1"
	_stopURL="$ip1_2.$ip2_2.$ip3_2.$ip4_2"
	#echo "Start URL:$_startURL Stop URL:$_stopURL"
	#порты
	str=$(echo -e $lport | sed "s/-/ /g")
	_startport=$(echo "$str" | awk '{print($1)}')
	_stopport=$(echo "$str" | awk '{print($2)}')
	if [ "$_stopport" == "" ]; then
	 _stopport=$_startport
	fi
	#
	echo "" > "$_freesitelist"
	#
	while( ((ip1_1 <= ip1_2)) ); do
	 if( ((ip2_1 > ip2_2)) ); then
	  ((ip2_1 = 1))
	 fi
	 while( ((ip2_1 <= ip2_2)) ); do
	  if( ((ip3_1 > ip3_2)) ); then
	   ((ip3_1 = 1))
	  fi
	  while( ((ip3_1 <= ip3_2)) ); do
	   if( ((ip4_1 > ip4_2)) ); then
	    ((ip4_1 = 1))
	   fi
	   while( ((ip4_1 <= ip4_2)) ); do
	    ((_cntport=_startport))
	    _startURL="$ip1_1.$ip2_1.$ip3_1.$ip4_1"
	    while ( ((_cntport <= _stopport)) ); do
	     #проверка памяти
	     mem=$(free | awk '/Mem:/ {print($4)}')
	     if ( (( mem > _memmin )) ); then
	      _sppfp1URL=$_startURL
	      _sppfp1port=$_cntport
	      _sfsfp1 &
	      usleep 1000
	      ((_cntport += 1))
	     else
	      sleep 3
	     fi
	    done
	    ((ip4_1 += 1))
           done
           ((ip3_1 += 1))
          done
	  ((ip2_1 += 1))
	 done
	 ((ip1_1 += 1))
	done
	echo "end" > "$_file_stat"
	echo "end"
}


case $_cmd in
	"help")
		_help
	;;
	"site")
		if [ "$_url" == "" ]; then
			echo "URL or IP ?"
			exit 1
		fi
		_site
	;;
	"sfsite")
		if [ "$_url" == "" ]; then
			echo "URL or IP ?"
			exit 1
		fi
		_search_free_sites
	;;
	*)
		echo "{help}"
	;;
esac


